package example_person_accounts_array;

public class PersonTest {

	public static void main(String[] args) {
		testAddAccount();
		testAddAccount_TooMany();
		testAddAccounts();
		testAddAccounts_TooMany();
		testGetAccount_Success();
		testGetAccount_Fail();
		testApplyInterest();
		testGetTotalBalance();	
		testGetTotalGoldAccounts();	
		testGetSmallestInterestRate();
		testGetGoldAccountWithSmallestInterestRate();
		testGetGoldAccounts();		
	}

	private static void testAddAccount() {
		System.out.println("testAddAccount()");
		Person p = new Person("Nate");
		BasicAccount ba = new BasicAccount("Dave", 1000.0);
		GoldAccount ga1 = new GoldAccount("Wendy", 500.0, 0.1);
		p.addAccount(ba);
		p.addAccount(ga1);
		System.out.println("added 2 accounts");
		System.out.println("Num Accounts:" + p.getNumAccounts());
		
	}
	
	private static void testAddAccount_TooMany() {
		System.out.println("\ntestAddAccount_TooMany()");
		Person p = buildPerson("Nate", createAccounts(10));
		BasicAccount ba = new BasicAccount("Dave", 1000.0);
		System.out.println("Added 10 accounts, Num Accounts:" + p.getNumAccounts());
		p.addAccount(ba);
		System.out.println("After trying to add 11th account, Num Accounts:" + p.getNumAccounts());
	}

	private static void testAddAccounts() {
		System.out.println("\ntestAddAccounts()");
		Person p = new Person("Nate");
		BasicAccount[] acnts = createAccounts(5);
		p.addAccounts(acnts);
		System.out.println("Should be 5, Num Accounts:" + p.getNumAccounts());
	}

	private static void testAddAccounts_TooMany() {
		System.out.println("\ntestAddAccountsTooMany()");
		Person p = new Person("Nate");
		BasicAccount[] acnts = createAccounts(12);
		p.addAccounts(acnts);
		System.out.println("Should be 10, Num Accounts:" + p.getNumAccounts());
	}
	
	private static void testGetAccount_Success() {
		System.out.println("\ntestGetAccount_Success()");
		Person p = new Person("Nate");
		BasicAccount ba = new BasicAccount("Dave", 1000.0);
		GoldAccount ga1 = new GoldAccount("Wendy", 500.0, 0.1);
		p.addAccount(ba);
		p.addAccount(ga1);
		BasicAccount a = p.getAccount(1);
		System.out.println("    Account added:" + ga1);
		System.out.println("Account retrieved:" + a);
	}

	private static void testGetAccount_Fail() {
		System.out.println("\ntestGetAccount_Fail()");
		Person p = new Person("Nate");
		BasicAccount ba = new BasicAccount("Dave", 1000.0);
		GoldAccount ga1 = new GoldAccount("Wendy", 500.0, 0.1);
		p.addAccount(ba);
		p.addAccount(ga1);
		BasicAccount a = p.getAccount(3);
		System.out.println("Account retrieved:" + a);
	}

	private static void testApplyInterest() {
		System.out.println("\ntestApplyInterest()");
		Person p = new Person("Nate");
		BasicAccount ba = new BasicAccount("Dave", 1000.0);
		GoldAccount ga1 = new GoldAccount("Wendy", 500.0, 0.1);
		System.out.println("Accounts before interest");
		System.out.println(ba);
		System.out.println(ga1);
		System.out.println();
		p.addAccount(ba);
		p.addAccount(ga1);
		p.applyInterest();
		BasicAccount a1 = p.getAccount(0);
		BasicAccount a2 = p.getAccount(1);
		System.out.println("Accounts interest interest");
		System.out.println(a1);
		System.out.println(a2);
	}

	private static void testGetTotalBalance() {
		System.out.println("\ntestGetTotalBalance()");
		Person p = new Person("Nate");
		BasicAccount ba = new BasicAccount("Dave", 1000.0);
		GoldAccount ga1 = new GoldAccount("Wendy", 500.0, 0.1);
		System.out.println("Accounts");
		System.out.println(ba);
		System.out.println(ga1);
		System.out.println();
		p.addAccount(ba);
		p.addAccount(ga1);
		double totalBalance = p.getTotalBalance();
		System.out.println("Total balance=" + totalBalance);
	}

	private static void testGetTotalGoldAccounts() {
		System.out.println("\ntestGetTotalGoldAccounts()");
		Person p = new Person("Nate");
		GoldAccount ga1 = new GoldAccount("Lenny", 2500.0, 0.15);
		BasicAccount ba = new BasicAccount("Dave", 1000.0);
		GoldAccount ga2 = new GoldAccount("Wendy", 500.0, 0.1);
		System.out.println("Accounts");
		System.out.println(ga1);
		System.out.println(ba);
		System.out.println(ga2);
		System.out.println();
		p.addAccount(ga1);
		p.addAccount(ba);
		p.addAccount(ga2);
		double totalBalance = p.getTotalGoldAccounts();
		System.out.println("Total balance Gold Accounts=" + totalBalance);
	}

	private static void testGetSmallestInterestRate() {
		System.out.println("\ntestGetSmallestInterestRate()");
		Person p = new Person("Nate");
		GoldAccount ga1 = new GoldAccount("Lenny", 2500.0, 0.15);
		BasicAccount ba = new BasicAccount("Dave", 1000.0);
		GoldAccount ga2 = new GoldAccount("Wendy", 500.0, 0.1);
		GoldAccount ga3 = new GoldAccount("Will", 1000.0, 0.12);
		System.out.println("Accounts");
		System.out.println(ga1);
		System.out.println(ba);
		System.out.println(ga2);
		System.out.println(ga3);
		System.out.println();
		p.addAccount(ga1);
		p.addAccount(ba);
		p.addAccount(ga2);
		p.addAccount(ga3);
		double smallestInterest = p.getSmallestInterestRate();
		System.out.println("Smallest Interest Rate=" + smallestInterest);
	}

	private static void testGetGoldAccountWithSmallestInterestRate() {
		System.out.println("\ntestGetGoldAccountWithSmallestInterestRate()");
		Person p = new Person("Nate");
		GoldAccount ga1 = new GoldAccount("Lenny", 2500.0, 0.15);
		BasicAccount ba = new BasicAccount("Dave", 1000.0);
		GoldAccount ga2 = new GoldAccount("Wendy", 500.0, 0.1);
		GoldAccount ga3 = new GoldAccount("Will", 1000.0, 0.12);
		System.out.println("Accounts");
		System.out.println(ga1);
		System.out.println(ba);
		System.out.println(ga2);
		System.out.println(ga3);
		System.out.println();
		p.addAccount(ga1);
		p.addAccount(ba);
		p.addAccount(ga2);
		p.addAccount(ga3);
		GoldAccount gaSmallest = p.getGoldAccountWithSmallestInterestRate();
		System.out.println("GoldAccount with Smallest Interest Rate=" + gaSmallest);
	}

	private static void testGetGoldAccounts() {
		System.out.println("\ntestGetGoldAccounts()");
		Person p = new Person("Nate");
		GoldAccount ga1 = new GoldAccount("Lenny", 2500.0, 0.15);
		BasicAccount ba = new BasicAccount("Dave", 1000.0);
		GoldAccount ga2 = new GoldAccount("Wendy", 500.0, 0.1);
		System.out.println("Accounts");
		System.out.println(ga1);
		System.out.println(ba);
		System.out.println(ga2);
		System.out.println();
		p.addAccount(ga1);
		p.addAccount(ba);
		p.addAccount(ga2);
		GoldAccount[] golds = p.getGoldAccounts();
		System.out.println("Gold Accounts");
		for(GoldAccount ga : golds) {
			System.out.println(ga);
		}
	}

	private static BasicAccount[] createAccounts(int num) {
		BasicAccount[] acnts = new BasicAccount[num];
		for(int i=0; i<num; i++) {
			String name = buildRandomName();
			double balance = buildRandomBalance();
			if(Math.random()<0.5) {
				acnts[i] = new BasicAccount(name, balance);
			}
			else {
				double intRate = buildRandomInterestRate();
				acnts[i] = new GoldAccount(name, balance, intRate);
			}
		}
		return acnts;
	}
	
	private static String buildRandomName() {
		String letters = "abcdefghijklmnopqrstuvwxyz";
		int randInt = (int)(Math.random()*26);
		String firstLetter = String.valueOf(letters.charAt(randInt));
		firstLetter.toUpperCase();
		randInt = (int)(Math.random()*26);
		String secondLetter = String.valueOf(letters.charAt(randInt));
		randInt = (int)(Math.random()*26);
		String thirdLetter = String.valueOf(letters.charAt(randInt));
		return firstLetter + secondLetter + thirdLetter;
	}

	private static double buildRandomBalance() {
		double[] balances = {500.0, 1000.0, 1500.0, 2000.0};
		int randInt = (int)(Math.random()*4);
		return balances[randInt];
	}

	private static double buildRandomInterestRate() {
		double[] intRates = {0.02, 0.05, 0.08, 0.1};
		int randInt = (int)(Math.random()*4);
		return intRates[randInt];
	}
	
	private static Person buildPerson(String name, BasicAccount[] acnts) {
		Person p = new Person(name);
		for(BasicAccount a : acnts) {
			p.addAccount(a);
		}
		return p;
	}
}
