package example_person_accounts_arraylist;

public class BasicAccount {
	protected double balance;
	protected String accountNumber;

	public BasicAccount(String accountNumber, double balance) {
		this.balance = balance;
		this.accountNumber = accountNumber;
	}

	public BasicAccount(String accountNumber) {
		this(accountNumber, 0.0);
	}

	public double getBalance() {
		return balance;
	}

	public String getAccountNumber() {
		return accountNumber;
	}

	public void deposit(double amount) {
		balance += amount;
	}

	public void withdraw(double amount) {
		balance -= amount;
	}

	public void applyInterest() {
		balance *= 1.05;
	}

	public void endOfMonth() {
		balance -= 5.0;
		if(balance<0.0)
			balance -= 25.0;
	}
	
	@Override
	public boolean equals(Object o) {
		if(!(o instanceof BasicAccount)) {
			return false;
		}
		BasicAccount otherAccount = (BasicAccount)o;
		return this.accountNumber.equals(otherAccount.accountNumber);
		
	}
	
	@Override
	public String toString() {
		return String.format("Basic: Account Number:%s, bal:$%,.2f", accountNumber, balance);
	}
}

