package exercise_corporation_salesreports_array;

public class CorporationReports {
	private SalesReport[] reports = new SalesReport[10];
	private int numReports = 0;

	public CorporationReports() {
	}
	
	public int getNumReports() {
		return numReports;
	}
	
	public void addReport(SalesReport rpt) {
		// Write code here
		if(numReports<reports.length) {
			reports[numReports++] = rpt;
		}
	}
	
	public DetailedSalesReport getReportLargestAverageSalesDetailed() {
		// Returns the DetailedSalesReport that has the maximum average 
		// sales value over only the Detailed reports
		// Hint: instanceof is used, and casting required
		// Write code here.
		DetailedSalesReport dsrMax=null;
		
		//Double.MAX_VALUE; will not work because no average sales will be larger than that.
		//double max=Double.MAX_VALUE; --> Original Code
		double max = 0.0;
		for(int i=0; i<numReports; i++) {
			SalesReport r = reports[i];
			if(r instanceof DetailedSalesReport) {
				if(r.averageSales() > max) {
					max = r.averageSales();
					dsrMax = (DetailedSalesReport)r;
				}
			}
		}
		return dsrMax;
	}
	
	public double getLargestAverageSalesDetailed() {
		// Returns the maximum average sales value over only the Detailed reports
		// Hint: instanceof is used, but not casting
		// Write code here.

		//Double.MAX_VALUE; will not work because no average sales will be larger than that.
		//double max=Double.MAX_VALUE; --> Original Code
		double max = 0.0;
		for(int i=0; i<numReports; i++) {
			SalesReport r = reports[i];
			if(r instanceof DetailedSalesReport) {
				if(r.averageSales() > max) {
					max = r.averageSales();
				}
			}
		}
		return max;
	}
	
	public DetailedSalesReport[] getDetailedReports() {
		// Returns an array of the DetailedSalesReports
		DetailedSalesReport[] detailedReports = new DetailedSalesReport[getNumDetailedReports()];
		int j=0;
		for(int i=0; i<numReports; i++) {
			SalesReport r = reports[i];
			if(r instanceof DetailedSalesReport) {
				detailedReports[j++] = (DetailedSalesReport)r;
			}
		}
		return detailedReports;
	}
	
	// Helper method to return the number DetailedReports
	private int getNumDetailedReports() {
		int count=0;
		for(int i=0; i<numReports; i++) {
			if(reports[i] instanceof DetailedSalesReport) {
				count++;
			}
		}
		return count;
	}

	public SalesReport getReport(int i) {
		if(i>=0 && i<numReports) {
			return reports[i];
		}
		return null;
	}
	
	public SalesReport removeReport(int i) {
		if(i>=0 && i<numReports) {
			SalesReport removedReport = reports[i];
			for(int j=i+1; j<numReports; j++) {
				reports[j-1] = reports[j];
			}
			numReports--;
		    return removedReport;
		}
		return null;
	}

	@Override
	public String toString() {
		StringBuilder msg = new StringBuilder("");
		for(int i = 0; i < numReports; i++) {
			if(reports[i] instanceof DetailedSalesReport) {
				//Works only for DetailedSalesReport
				msg.append("\nDaitledSalesReport ==> \n");
			}
			else {
				//Works only for SalesReport
				msg.append("\nSalesReport ==> \n");
			}
			//Works for both
			String report = reports[i].getHeader() + "\n" + reports[i].getBody();
			msg.append(report + "\n");
		}
		return msg.toString();
	}
}
